---
title: "Tutoriel git <small><br> <hr> [introduction](index.html) | [installation](installation.html) | [dépôt local](depot_local.html) | [dépôt distant](depot_distant.html) | [branches](branches.html) | [forks](forks.html) <hr> </small>"
output:
    toc: true
---

* * * * *

# Dépôt distant (sauvegarder un projet sur un serveur)

Git permet de synchroniser un dépôt local avec un dépôt distant (sur un
serveur).  Il existe des serveurs comme github qui permettent d'héberger
gratuitement des dépôts publics (visibles par tout le monde).

Le serveur gogs du SCOSI vous permet d'héberger des dépôts publics ou privés.
Il dispose d'une page web vous permettant de gérer vos projets. Pour cela,
allez à l'adresse
[https://gogs.univ-littoral.fr](https://gogs.univ-littoral.fr) et entrez vos
identifiants du portail ULCO :

![](depot_distant_01.png)

Une fois identifié, le site vous affiche une page d'accueil (derniers commits,
dépôts actifs...) :

![](depot_distant_02.png)

## Créer un dépôt sur un serveur git

Pour créer un nouveau dépôt distant, allez sur la page du serveur gogs et
cliquez "New Repository".

![](depot_distant_03.png)

Entrez le nom du dépôt distant à créer (évitez les espaces), puis cliquez
"Create Repository".

![](depot_distant_04.png)

Le dépôt distant est alors créé et une page vous indique comment le récupérer
localement. Attention, il y a une méthode plus simple que celle indiquée (cf
section suivante).

![](depot_distant_05.png)

## Créer un dépôt local à partir d'un dépôt distant

La commande `git clone ...` permet de récupérer un dépôt distant sur votre
machine (cf image ci-dessous). Pensez à mettre votre login après le "https://".

![](depot_distant_06.png)

## Ajouter un dépôt local à un dépôt distant

Si vous avez déjà créé et modifié un dépôt local, vous pouvez le synchroniser
avec un dépôt distant en utilisant les commandes `git remote add origin ...`
puis `git push -u origin master`. Sinon, utilisez plutôt la méthode de la
section précédente.

![](depot_distant_07.png)

## Récupérer les commits d'un dépôt distant

La commande `git pull` permet de récupérer les éventuelles modifications sur le
serveur et de les intégrer dans votre dépôt local.

![](depot_distant_08.png)

## Envoyer les commits locaux sur un dépôt distant

La commande `git push` permet d'envoyer vos commits locaux sur le serveur.

![](depot_distant_09.png)

Les commits/fichiers envoyés sur le serveur sont alors visibles sur la page web.

![](depot_distant_10.png)

Vous pouvez également toujours voir le contenu de votre dépôt avec un client
graphique.

![](depot_distant_11.png)

## Résoudre des conflits

Imaginez que vous avez modifié et commité un fichier, et que vous voulez
l'envoyer sur le serveur. Pour cela, il faut d'abord faire un `git pull` avant
le `git push` au cas où l'un de vos collaborateurs aurait envoyer une
modification sur le serveur entre temps. 

Si des modifications ont été faites en parallèle, git est souvent capable de
les fusionner mais parfois il n'arrive pas à résoudre le conflit et il vous
demande de le faire manuellement.

![](depot_distant_12.png)

Pour résoudre un conflit, il suffit d'ouvrir le fichier en cause et de
remplacez les zones marquées par le contenu que vous voulez obtenir. 
Il existe des outils graphiques comme `meld` qui peuvent vous y aider.

![](depot_distant_13.png)

Une fois les conflits édités, vous pouvez commiter et pusher vers le serveur.

![](depot_distant_14.png)

## Résumé et méthode de travail

Résumé des commandes git précédentes :

---|---|
`git clone` | récupère un dépôt distant |
`git pull` | récupère les modifications du dépôt distant et les intègre dans le dépôt local |
`git push` | envoie les commits du dépôt local sur le dépôt distant |

Quelques conseils de méthode de travail :

- utilisez la page
  [https://gogs.univ-littoral.fr](https://gogs.univ-littoral.fr) pour créer et
gérer vos dépôts distants.
- récupérez vos nouveaux dépôts distant avec `git clone`
- récupérez les modifications du serveur avec `git pull`
- faites un `git pull` avant d'envoyer vos nouveaux commits sur le serveur (`git push`)

## Exercice

TODO

* * * * *

## Branches (travailler en équipe)

TODO

## Afficher les branches 
git log --graph --all --oneline --decorate

## Créer une nouvelle branche locale

## Changer de branche

## Fusionner des branches

## Envoyer une branche sur un dépôt distant

## Afficher les branches distantes

## Terminer une branche locale

## Terminer une branche distante

## Supprimer un commit déjà pushé (DANGER !!!)
git reset --hard e6c8e8e
git push origin HEAD:master -f
git reset --hard e6c8e8e

![](branche_01.png)
![](branche_02.png)
![](branche_03.png)
![](branche_04.png)
![](branche_05.png)
![](branche_06.png)
![](branche_07.png)
![](branche_08.png)
![](branche_09.png)
![](branche_10.png)
![](branche_11.png)
![](branche_12.png)
![](branche_13.png)
![](branche_14.png)
![](branche_15.png)
![](branche_16.png)
![](branche_17.png)
![](branche_18.png)
![](branche_19.png)
![](branche_20.png)
![](branche_21.png)

## Résumé et méthode de travail

Résumé des commandes git précédentes :

---|---|
`git ` | |

Quelques conseils de méthode de travail :

- TODO


## Exercice

TODO

* * * * *

[Retour au début de la page](#header)

[Retour à la page d'accueil](../../index.html)

Dernière mise à jour : 2016-03-05

